extern vec2 screen = vec2(800.0f, 600.0f);
extern vec2 sundir = vec2(0.0f, 0.0f);
extern Image colormap;

const float sunheight = 1.0f;
const vec3 terrain = vec3(0.0f, 0.7f, 0.0f);
const vec3 ambient = vec3(0.01f, 0.0f, 0.015f);

// assume color is green for now

vec4 effect(vec4 color, Image texture, vec2 texcoords, vec2 pixcoords) {
	// source color
	vec4 source = Texel(texture, texcoords);


	vec3 sunvector = normalize(vec3(sundir, -sunheight));
	vec3 normal = normalize(source.rgb-vec3(0.5f, 0.5f, 0.5f));
	vec4 data = Texel(colormap, texcoords);
	float height = (data.r*data.g);

	float l = dot(normal, -sunvector)*0.5f +0.5f;
	l *= 1/((sunheight-height)*0.7f+1);


	vec4 texcolor = vec4(terrain*l+ambient, 1.0f);
	return texcolor * color;
}